% -*- mode: latex; eval: (electric-indent-mode 0);
\documentclass[a4paper, titlepage=firstiscover]{scrbook}
\let\hhhbar\hbar
\usepackage{marginnote}
\usepackage{setspace}
\usepackage{oreally}
\usepackage{covermia}
%\documentclass[11pt,a4paper]{report}
%\makeatletter
%\@ifundefined{pdfoutput}{}{
%  \usepackage[pdfborder={1 1 0}, colorlinks=false]{hyperref}
%%  \usepackage{thumbpdf}
%}
%\makeatother
\usepackage{steinmetz}
\usepackage[margin=1.5in]{geometry}
\usepackage{amsmath}
\usepackage{amsbsy}
\usepackage{amssymb}
\usepackage{amsthm,amsfonts}
\usepackage{epsf,epsfig}
\usepackage{times}
\usepackage{mathptmx}
\usepackage{color}
\usepackage{nomelabel}
\usepackage[english]{babel}
\usepackage{srcltx}
\usepackage[boxed]{algorithm2e}

\input{notes-def}
\newcommand{\F}[2]{{\tilde {#1}}({#2})}
\renewcommand{\perdef}{\stackrel{\text{def}}{=}}
\newcommand{\cd}{\operatorname{cd}}
\newcommand{\arccosh}{\operatorname{arccosh}}
\newcommand{\arcsinh}{\operatorname{arcsinh}}
\newcommand{\Hi}[1][N]{H_{#1}^{(I)}}
\newcommand{\Hii}[1][N]{H_{#1}^{(II)}}
\newcommand{\cfeed}{C_{\text{feed}}}
\newcommand{\rfeed}{R_{\text{feed}}}

\newcommand{\rp}{r_p}
\newcommand{\ra}{r_s}
\newcommand{\fp}{f_p}
\newcommand{\fa}{f_s}
\newcommand{\h}[1][H]{\widehat #1}
\def\cebi;{Chebyshev}
\def\chebi;{Chebyshev}

\newcommand{\order}{N}
\newcommand{\ftaglio}{f_c}
\newcommand{\bessel}[1][\order,\ftaglio]{{\mathfrak B}_{#1}}
\newcommand{\bpoly}[1][\order]{\theta_{#1}}
\newcommand{\cebypoly}[1][\order]{T_{#1}}
\let\cpoly\cebypoly
\let\cpoli\cebypoly
\newcommand{\kbutter}{K_{\buttername}}
\newcommand{\butter}[1][\order,\ftaglio]{\bbutter #1;}
\def\bbutter#1,#2;{\widehat {\buttername}_{#1, #2}}
\newcommand{\tfbutter}[1][\order,\ftaglio]{\tfbbutter #1;}
\def\tfbbutter#1,#2;{{\buttername}_{#1, #2}}
\newcommand{\buttername}{\mathcal B}
\newcommand{\chebiI}[1][\order,\ftaglio,\epsilon]{\cchebi #1;I}
\newcommand{\chebiII}[1][\order,\ftaglio,\epsilon]{\cchebi #1;{II}}
\def\cchebi#1,#2,#3;#4{\widehat {\mathcal C}_{#1, #2,#3}^{(#4)}}
\let\cebiI\chebiI
\let\cebiII\chebiII

\newcommand{\gaussian}[1][.,]{\ggauss #1;}
\def\ggauss#1,#2;{\sedotelse{#1}{\widehat{\mathcal G}}{\widehat{\mathcal G}_{#1,#2}}}

\newcommand{\elliptic}[1][\epsilon,\xi]{\eelliptic #1;}
\def\eelliptic#1,#2;{\widehat {\ellipname}_{#1, #2}}
\newcommand{\ellipname}{{\mathcal E}}
\newcommand{\ellrat}[1][\order,\xi]{\eellrat #1;}
\def\eellrat#1,#2;{R_{#1,#2}}

\newcommand{\id}{\operatorname{id}}
\newcommand{\fourier}{\mathcal {F}}
\newcommand{\X}{X}

\title{Analog filter design for DSP students}
\coverimage{\includegraphics[width=15cm]{fin_lunga.png}}
\author{Riccardo Bernardini}

\begin{document}
\maketitle
\tableofcontents
\chapter{Generalities}

\section{Filter design problem statement}

\paragraph{Filter spec}

Our goal is to design a low-pass filter with the following specs

\begin{itemize}
\item In the \emph{pass band} the modulus of the frequency response must not
  be smaller than $\rp = 1-\delta_p$.  We will call $\rp$ the
  \emph{pass band ripple} and $\delta_p$ the \emph{tolerance}.
\item In the \emph{stop band} the modulus of the frequency response
  must be \emph{not larger} than $\ra$.  We will call $\ra$ the
  \emph{stop band ripple}.
\item The \emph{pass band ends} at $\fp$, and the \emph{stop band
begins} at $\fa > \fp$.
\end{itemize}
%

\paragraph{The Problem}

Given the 4-tuple spec $[\fp, \fa, \rp, \ra]$ find a rational function
$H : \complessi \to \complessi$ of \emph{minimum order} such that
%
\begin{subequations}
  \label{eq:problem}
  \begin{align}
    \rp^2 \leq \abs{H(j 2\pi f)}^2 &\leq 1 & 0 &\leq f \leq \fp \\
    \abs{H(j 2\pi f)}^2 &\leq \ra^2 & \fa &\leq f 
  \end{align}
\end{subequations}

\begin{commento}
  ~
  \begin{enumerate}
  \item In these notes we define the \emph{order} of a rational
    function the degree of the denominator, that is, the number of
    poles of the rational function.  The order of a rational function
    can be considered as a measure of the \emph{cost} of the filter.
  \item In \er{eq:problem} we give constraints on $\abs{H(j 2\pi
    f)}^2$, the square modulus of the frequency response.  Although it
    would be possible to express the same constraint using the modulus
    $\abs{H(j 2\pi f)}$ (without squaring), form \er{eq:problem} will
    prove to be more convenient.
  \item When convenient we will use $\h(f)$ to denote the frequency
    response at frequency $f$, that is, $\h(f)=H(j 2\pi f)$.
  \end{enumerate}
\end{commento}

\section{Filter classes}

Although nowadays it could be possible a \emph{brute force} approach
where the coefficients of the rational function $H$ are found via
numerical optimization, it is common to search for $H$ in a specific
\emph{filter class}.  A filter class can be thought as a set of
modulus squared frequency responses, parameterized by few parameters.

For example, the modulus square of the frequency response of a
\emph{Butterworth filter} can be written as
%
\begin{equation}
  \label{eq:b1}
  \abs{\butter(f)}^2 = \frac 1 {1 + (f/\ftaglio)^{2\order}}
\end{equation}
%
where the two parameters are the order $\order$ and the cut-off
frequency $\ftaglio$.  Therefore, in order to select a specific
Butterworth filter one only needs to choose its order and the cut-off
frequency.

As another example, consider the class of \emph{\chebi;-I filters}.
The frequency response of a generic \chebi;-I filter $\chebiI$ can be
written as
%
\begin{equation}
  \label{eq:c1}
  \abs{\chebiI(f)}^2 = \frac{1}{1 + \epsilon^2 T_{\order}^2(f/\ftaglio)}
\end{equation}
%
where $\order$ and $\ftaglio$ still are the filter order and the
cut-off frequency (with the exact definition slightly different from
the Butterworth case) and $\epsilon$ is an additional parameter that
is used to adjust the pass-band ripple.  Again, in order to select a
specific \chebi; filter, it suffices to choose the three parameters
$\order$, $\ftaglio$ and $\epsilon$.

Table~\ref{tbl:classes} list the main filter classes.  Every class has
some special characteristic that characterizes it and that can help in
selecting the most suitable class for a specific application.  Note
that some filter classes are characterized by a only-pole transfer
function, that is the numerator of the transfer function is just a
constant and the filter has no zeros.  The distinction between
only-pole classes and pole-and-zero classes is important because
different schemes are required if the transfer function has zeros.

\begin{table}
  \caption{Main filter classes \label{tbl:classes}}
  
  \centering
  \begin{tabular}{lcp{0.7\textwidth}}
    \multicolumn{1}{c}{Class} &
    \multicolumn{1}{c}{Only poles?} &
    \multicolumn{1}{c}{Notes} \\
    \hline
    Gaussian & Yes & Not rational, it must be approximated with a
    rational function. No overshoot in the step response.  Optimal
    time-frequency support.  Frequency response not very steep. \\
    Bessel & Yes & Best approximation to a linear phase filter.
    Minimal overshoot in the step response. Frequency response not
    very steep. \\
    Butterworth & Yes & Maximally flat frequency response.  Monotone
    frequency response \\
    \cebi;-I & Yes & More efficient than Butterworth.  Equiripple in
    pass-band, monotone in stop-band\\
    \cebi;-II & No & Dual to \cebi;-I.  Equiripple in
    stop-band, monotone in pass-band\\
    Elliptic & No & Most efficient filter class (minimum
    order). Equiripple both in stop-band and pass-band.
  \end{tabular}
\end{table}

\section{From $\abs{\h(f)}^2$ to $H(s)$}
\label{sec:abs2h}

One problem with the filter class approach is that after having chosen
the filter parameters, we get the square modulus of the frequency
response, for example, \er{eq:b1} or \er{eq:c1}, but not the
\emph{transfer function} which is the datum we actually need since
from the transfer function we can derive a circuit that implements
it.  Therefore, we need to solve the following problem

\begin{problem}
  \label{pr:1}
  Given a rational function representing the square modulus of the
  frequency response of a filter, that is,
  \begin{equation}
    \abs{\h(f)}^2 = \frac{\h[P](f)}{\h[Q](f)}
  \end{equation}
  %
  find a rational function
  %
  \begin{equation}
    H(s) = \frac{B(s)}{A(s)}
  \end{equation}
  %
  such that
  %
  \begin{equation}
    \abs{H(j2\pi f)}^2 = \abs{\h(f)}^2
  \end{equation}
  %
  or, equivalently,
  %
  \begin{equation}
    \frac{\abs{B(j2\pi f)}^2}{\abs{A(j2\pi f)}^2} = \frac{\h[P](f)}{\h[Q](f)}
  \end{equation}
\end{problem}
%
It is quite clear that Problem~\ref{pr:1} can be solved if we can
solve the following restricted problem.

\begin{problem}
  \label{pr.2}
  Let $P : \reali \to \reali$ be a polynomial
  %
  \begin{equation}
    P(x) = \sum_k p_k x^x
  \end{equation}
  %
  such that $P(f)=P(-f)$
  and $P(f) \geq 0$ for every $f$.  Find a polynomial $B : \complessi
  \to \complessi$ with real coefficients such that
  \begin{equation}
    P(f) = \abs{B(j 2\pi f)}^2
  \end{equation}
\end{problem}
%
Clearly, if we know how to solve Problem~\ref{pr.2}, then we can apply
the solution to the numerator and the denominator of $\h(f)$ in
Problem~\ref{pr:1}.

Call
%
\begin{equation}
  \label{eqs}
  \overline B(s)=B(s) B(-s) = \sum_n \beta_n s^n
\end{equation}
%
and observe that

\begin{enumerate}
\item Since $P$ is even (that is, $P(f)=P(-f)$), then $p_{2k+1}=0$ for every
  $k\in\interi$.
\item Also $\overline B$ is even, that is, $\overline B(s)=\overline
  B(-s)$.  This implies that $\beta_{2k+1}=0$ for every
  $k\in\interi$.
\end{enumerate}

Now observe that the following equality holds
\begin{equation}
  P(f) = \abs{B(j2\pi f)}^2 = B(j2\pi f)B(-j2\pi f)= \overline B(j2\pi f)
\end{equation}
that can be rewritten as
\begin{equation}
  \label{eqz}
  \sum_{k} p_{2k} f^{2k}
  = \sum_{k} \beta_{2k} (j2\pi)^{2k} f^{2k}
  = \sum_{k} \beta_{2k} (2\pi)^{2k} (-1)^k f^{2k}
\end{equation}
%
where we exploited the fact that the coefficients of $P$ and
$\overline B$ corresponding to odd powers are zero.  Since \er{eqz}
must hold for every $f$ it follows that it must be
%
\begin{equation}
  \label{eqa}
  \beta_{2k} = (-1)^k \frac{p_{2k}}{(2\pi)^{2k}}
\end{equation}
%
Using \er{eqa} we can find the coefficients of $\overline B$ from
$P$.  Now we need to factorize $\overline B$ as in \er{eqs}.

Since $\overline B$ is even, it follows that the zeros of $\overline
B(s)$ are pairwise opposite, that is, if $z_k$ is a zero of $\overline
B$, then also $-z_k$ is a zero.  By defining $B(s)$ as the polynomial
with the zeros with negative real part, we solve Problem~\ref{pr.2}.

\section{Action of the cut-off frequency}

Every filter class has at least two parameters: the filter order
$\order$ and the cut-off frequency $\ftaglio$.  In every filter class
the cut-off frequency $\ftaglio$ is used as a scale factor as shown in
\er{eq:b1} and \er{eq:c1}.  In a sense, one could say that the filters
in the class with $\ftaglio=1$ are ``prototypes,'' with unitary
cut-off frequency, that are stretched in frequency (by dividing the
frequency by $\ftaglio$) to get the desired cut-off frequency.  This
has some interesting consequences.

\subsection{Filter-classes are scale invariant}

\newcommand{\fclass}{\mathcal F}

The way the cut-off frequency is used implies that every filter class
is scale invariant, in the sense that if $H(f)$ belongs to a class
$\fclass$, then every scaled version $H_\alpha(f) \perdef H(\alpha
f)$, $\alpha > 0$, will belong to $\fclass$ too, the difference
between $H$ and $H_\alpha$ being only the cut-off frequency.  This
implies the following fact.

\begin{fact}
  The cost of a filter (measured with its order) satisfying specs
  $[\fp, \fa, \rp, \ra]$ depends on $\fp$ and $\fa$ only via their
  ratio $\fa/\fp$ or, alternatively, on the transition band measured
  logarithmically (e.g., in octaves, decades, \ldots) 
\end{fact}

\begin{example}
  \label{ex:1}
For example, a filter, with given $\rp$ and $\ra$, with $\fp=100$~Hz
and $\fa=200$~Hz (one octave) costs as a filter with the same $\rp$
and $\ra$ but $\fp=1$~MHz and $\fa=2$~MHz (still one octave).
\end{example}

\begin{commento}
  A different way to see the same result is to observe that if we want
  a maximum attenuation of $\rp$~dB in pass-band and a minimum
  attenuation of $\ra$~dB in stop-band, the filter frequency response
  in the transition band must have an average slope of
  %
  \begin{equation}
    \label{eq:sl}
    \frac{\rp-\ra}{\log_{10}(\fa/\fp)} \qquad \text{dB/decade}
  \end{equation}
  %
  Observe that the two filters of Example~\ref{ex:1} have the same
  slope, when measured in dB/decade.

  How can we increase the slope in transition band?  By adding more
  poles!  Remember from the rules for the asymptotic Bode diagram,
  that every pole increases the slope in the frequency response by
  20~dB/decade, therefore we expect that the order of the filter will
  be roughly (\textbf{very, very roughly}) proportional to the slope
  \er{eq:sl}; therefore, we expect that two filters with the same
  slope will have the same order.

  \textbf{Warning:} the \textbf{proportionality} between slope
  \er{eq:sl} and the filter order has been deduced using the fact that
  every pole adds 20~dB/decade, but this is true only in an
  \textbf{asymptotic} sense.  In practice one observes that there is
  \textbf{not a strict proportionality} between the slope in
  transition band and the filter order, nevertheless, it remains true
  that the slope increases with the filter order.
\end{commento}

\subsection{Scaling the transfer function}

It is clear that the scaling operated by $\ftaglio$ acts also on the
transfer function.  Let $H_1$ be the transfer function with
$\ftaglio=1$ and suppose that it is a pure-pole transfer function,
given as product of second order factors, that is,
%
\begin{equation}
  \label{eq.h1}
  H_1(s) = \prod_k \frac{1}{s^2 + a_k s + b_k}
\end{equation}
%
\begin{commento}
  Clearly \er{eq.h1} assumes that the order of $H_1$ is even; if the
  order of $H_1$ is odd, a further single-pole term $1/(s+b)$ is
  present.  The differences between even and odd order are minimal,
  and we will consider only the even order case.
\end{commento}
%
In practice it is quite common to find $H_1$ expressed as in
\er{eq.h1} since analog filters are usually implemented as a cascade
of second order stages, both for simplicity and robustness (see
Chapter~\ref{chap:implementation}).

Starting from \er{eq.h1} it is possible to find a similar
decomposition for the filter with the desired $\ftaglio$, that is,
$H_{\ftaglio}(s) = H_1(s/\ftaglio)$ as follows
%
\begin{equation}
  \label{eq.fc}
  H_{\ftaglio}(s) = H_1(s/\ftaglio) = \prod_k \frac{1}{(s/\ftaglio)^2
    + a_k s/\ftaglio + b_k} = \prod_k \frac{\ftaglio^2}{s^2
    + a_k\ftaglio s + b_k\ftaglio} 
\end{equation}
%
\begin{commento}
  In the specific case of Bessel and Butterworth filters (that have
  only two parameters: $\order$ and $\ftaglio$), it is possible to
  find tables of coefficients $a_k$ and $b_k$ indexed by the order
  $\order$.  This makes the design for these classes quite simple:
  \begin{itemize}
  \item From the specs find $\order$ and $\ftaglio$
  \item Find in the table the coefficients of the prototype $H_1$ with
    $\ftaglio=1$ 
  \item Scale the coefficients according to \er{eq.fc}
  \end{itemize}
\end{commento}

\chapter{Gaussian filters}
\label{chap:gaussian}

\section{Prototype filter}

The class of Gaussian filters is quite peculiar since it is the only
class of non-rational frequency responses and where the order $\order$
does not improve the selectivity of the filter, but only the
approximation to the ideal Gaussian frequency response.

A Gaussian filter is characterized by having a Gaussian as impulse
response; this implies that also the frequency response is a
Gaussian. More precisely, if we define the cut-off frequency of a
Gaussian filter the frequency where the filter has 3~dB attenuation,
the $\ftaglio=1$ prototype is
%
\begin{equation}
  \label{eq.g0}
  \abs{\gaussian(f)}^2 = e^{-\ln(2) f^2}
\end{equation}
%
It follows that the prototype frequency response is
%
\begin{equation}
  \gaussian(f) = \exp\left(-\frac{\ln(2)}{2} f^2\right)
\end{equation}
%
and the impulse response is
%
\begin{equation}
  g(t) = \sqrt{\frac{2 \pi}{\ln 2}} \exp\left(-\frac{2 \pi^2}{\ln 2} t^2\right)
\end{equation}
%
An ideal Gaussian filter is not implementable, since its frequency
response is not a rational function; in order to implement it we need
to approximate it with a rational function and this can be easily done
by expanding the exponential in a power series, that is,
%
\begin{equation}
  \label{eq.g1}
  \abs{\gaussian(f)}^2 = e^{-\ln(2) f^2}
   = \frac 1 {e^{\ln(2) f^2}}
   = \frac 1 {\sum_{k\geq 0} \frac{(\ln 2)^k}{k!} f^{2k}}
   \approx \frac 1 {\sum_{k=0}^\order \frac{(\ln 2)^k}{k!} f^{2k}}
\end{equation}
%
Equation \er{eq.g1} approximate the ideal prototype frequency response
\er{eq.g0} with a pure-poles rational function.  By applying to
\er{eq.g1} the procedure of Section~\ref{sec:abs2h} it is easy to find
the corresponding transfer function.  Note that by increasing the
order you do not improve the selectivity of the filter, but how well
you approximate the ideal frequency response.

\section{Pros and Cons}

Gaussian filters are quite peculiar. They have a frequency response
(and, therefore, a selectivity) that is fixed and cannot be modified
by changing $\order$.  Other filters have better selectivity
properties.

A main advantage of a Gaussian filter is that its step response has no
overshoot since the impulse response is always positive.  Another
interesting characteristic of Gaussian filters is that they are
maximally concentrated in the time-frequency plane (see
Appendix~\ref{app:tf}). 


\chapter{Bessel filters}
\label{chap:bessel}

\section{Definition}

The order $\order$ Bessel filter is given directly by its transfer
function
%
\begin{equation}
  \bessel(s) = \frac{\bpoly(0)}{\bpoly(s/\ftaglio)}
\end{equation}
%
where $\bpoly$ is the \emph{reverse Bessel polynomial} of order
$\order$ defined as
%
\begin{equation}
  \bpoly(x) = \sum_{k=0}^\order \frac{(\order+k)!}{(\order-k)! k!}
  \frac{x^{\order-k}}{2^k}
\end{equation}
%
or, alternatively, via the recursive relation
%
\begin{subequations}
\begin{align}
  \bpoly[0](x) &= 1 \\
  \bpoly[1](x) &= x+1 \\
  \bpoly(x) &=(2\order-1) \bpoly[\order-1](x)+ x^2\,\bpoly[\order-2](x) 
\end{align}
\end{subequations}
%
The first few polynomials of order $\order > 1$ are
\begin{align}
  \bpoly[2](x) &= x^2+3x+3 \\
  \bpoly[3](x) &= x^3+6x^2+15x+15 \\
  \bpoly[4](x) &= x^4+10 x^3+45 x^2+105 x+105 \\
  \bpoly[5](x) &= x^5 + 15 x^4 + 105 x^3 + 420 x^2 + 945 x + 945
\end{align}
%
Bessel filters have the characteristic of having a phase maximally
linear (more precisely, a group delay maximally flat).  This is
achieved by requiring that the derivatives of the phases of order $3$,
$5$, \ldots, $2\order-1$ are zero in the origin (the derivatives of
order even are automatically zero, while the first derivative
represents the group delay).

\section{Features}

Since all the degree of freedoms are used to impose the linear phase
constraints, the frequency response is less selective than other
filters, see \fref{bessel.freq}a that shows the frequency responses of
several Bessel filters, scaled in order to have -3~dB at $f=1$ for
all the filters.  Note also that the slope of the frequency response
initially increases for small orders, but then it ``saturates.''  This
because Bessel filters of large order become Gaussian filter, see
\fref{bessel.freq}b that shows the impulse responses corresponding to
the filters in \fref{bessel.freq}a.  Note that the impulse responses
are almost always non-negative (see zoom in \fref{bessel.freq}c), this
means that Bessel filters have small overshoot.

\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{filtri_bessel}
    &
    \unafigura[0.47\textwidth]{bessel_impulse_rescaled} \\
    (a) & (b)\\
    \multicolumn{2}{c}{\unafigura[0.47\textwidth]{bessel_impulse_zoom_on_tail}}
    \\
    \multicolumn{2}{c}{(c)} 
  \end{tabular}
  \caption{Plots of (a) frequency responses of Bessel filters (b) the
    corresponding impulse responses (c) zoom on the tails of the
    impulse responses  in (b)  \label{fig:bessel.freq}}
\end{figure}



\section{Converting to digital}

The main feature of a Bessel filter is its linear phase.  However, at
discrete time we have an easier way of getting linear phase filters:
just use a symmetric FIR! Because of this, the importance of Bessel
filters for DSP is probably marginal, although they could be
interesting for having a linear phase filter with small computational
cost.

Since the main characteristic of a Bessel filter is time-domain
related, the best way to convert it to digital is to use the impulse
invariant rather than the bilinear transformation.


\chapter{Butterworth filters}
\label{chap:butterworth}

\section{Definition}

The square modulus of the frequency response of a Butterworth filter is
%
\begin{equation}
  \label{eq.butter}
  \abs{\butter(f)}^2 = \frac 1 {1 +(f/\ftaglio)^{2\order}}
\end{equation}
%
From \er{eq.butter} it is easy to deduce that
%
\begin{enumerate}
\item The frequency response is monotone decreasing
\item $\butter(0)=1$
\item $\butter(f)$ attenuates 3~dB at $\ftaglio$, for every $\order$
\item When $\order$ increases, $(f/\ftaglio)^{2\order}$ remains near
  to zero when $f <\ftaglio$, making $\butter(f)$ near to $1$ when $f
  <\ftaglio$.  When $f>\ftaglio$, $(f/\ftaglio)^{2\order}$ diverges
  rapidly, making $\butter(f)$ decay rapidly to zero when $f>\ftaglio$.
\end{enumerate}
%
In other words, all the frequency responses are equal to $-3$~dB at
$\ftaglio$ and $\order$ determines the filter slope, that is, how fast
it goes from pass-band to stop-band.

\section{Design procedure}

The design procedure is quite easy and exploits the monotonicity of
the frequency response.  Remember that our problem is to find $\order$
and $\ftaglio$ such that \er{eq:problem} is satisfied, that is,
$\butter(f)$ is larger than $\rp$ in pass-band and smaller than $\ra$
in stop-band.  Since Butterworth frequency responses are monotone,
said constraints are satisfied if and only if they are satisfied on
the edges of the two bands; that is, in the Butterworth case
constraints \er{eq:problem} are equivalent to

\begin{align}
  \label{eq.but.d1}
  \abs{\butter(\fp)}^2
  =\frac{1}{1+(\fp/\ftaglio)^{2\order}} &\geq \rp^2
  &   \abs{\butter(\fa)}^2 =\frac{1}{1+(\fa/\ftaglio)^{2\order}} &\leq \ra^2
\end{align}
%
From \er{eq.but.d1} we derive
%
\begin{align}
  \label{eq.but.d2}
  (\fp/\ftaglio)^{2\order} &\leq (1/\rp)^2-1
  &   (\fa/\ftaglio)^{2\order} &\geq (1/\ra)^2-1
\end{align}
%
We can get rid of $\ftaglio$ by dividing the two inequalities
%
\begin{equation}
  (\fa/\fp)^{2\order} \geq \frac{(1/\ra)^2-1}{(1/\rp)^2-1}=\kbutter(\ra,\rp)
\end{equation}
%
where we introduced the shorthand
\begin{equation}
  \label{eq.but.k}
  \kbutter(\ra,\rp) = \frac{(1/\ra)^2-1}{(1/\rp)^2-1}
%  = \frac{1/\ra^2}{1/\rp^2} \frac{1-\ra^2}{1-\rp^2}
  %  = \frac{\rp^2}{\ra^2} \frac{1-\ra^2}{1-\rp^2}
    = \frac{\rp^2/(1-\rp^2)}{\ra^2/(1-\ra^2)}
\end{equation}
which gives us
%
\begin{equation}
  \label{eq.but.o}
\order \geq \frac 12 \frac{\log  \kbutter(\ra,\rp)}{\log(\fp/\fa)}
\end{equation}
%
Since $\order$ must be integer we deduce
%
\begin{equation}
  \label{eq.but.order}
  \order =\ceil{\frac 12 \frac{\log  \kbutter(\ra,\rp)}{\log(\fp/\fa)}}
\end{equation}
%
Now that we know $\order$ we can turn back to \er{eq.but.d2} that becomes
%
\begin{align}
  \label{eq.but.d3}
  \fp/\ftaglio &\leq \sqrt[2\order]{(1/\rp)^2-1}
  &   \fa/\ftaglio &\geq \sqrt[2\order]{(1/\ra)^2-1}
\end{align}
%
which is equivalent to
%
\begin{equation}
  \label{eq.but.fc}
  \frac{\fp}{\sqrt[2\order]{(1/\rp)^2-1}}
  \leq
  \ftaglio
  \leq
  \frac{\fa}{\sqrt[2\order]{(1/\ra)^2-1}}
\end{equation}
%
According to \er{eq.but.fc}, $\ftaglio$ can assume a range of values,
said range is not empty because we choose $\order$ according to
\er{eq.but.order}.  If $\ftaglio$ assumes the smallest value, then the
filter satisfies exactly the specs at the edge of the pass band; if
$\ftaglio$ assumes the largest admissible value, then the filter
satisfies exactly the specs at the edge of the stop band, see also
Example~\ref{ex.butter}.

\begin{commento}
  Observe that $\order$ in \er{eq.but.order} depends on
  $\log(\fa/\fp)$, that is, the transition band measured
  logarithmically, as anticipated.  Moreover, from \er{eq.but.k} it is
  easy to see that the right hand side of \er{eq.but.o} is akin
  (although not exactly equal) to the slope in transition band
  measured in dB/decades (or dB/octave, or \ldots).  Therefore,
  \er{eq.but.order} shows that $\order$ is (approximately)
  proportional to the slope in the transition band, as expected.
\end{commento}

\begin{example}
  \label{ex.butter}
  Consider the following specs: $\fp=3\,000$~Hz, $\fp=5\,000$~Hz,
  $\rp=0.9$, $\ra=0.03$ (i.e., 30~dB of attenuation).  Using the
  formulas above we get
  \begin{equation}
    \begin{aligned}
      \log_{10} \kbutter(\ra,\rp) &= 3.66 \\
      \log_{10} (\fa/\fp)&=0.22~\text{decades}\\
      \order&=\ceil{8.26}=9 \\
      3251.7~\text{Hz} &\leq \ftaglio \leq 3390.5~\text{Hz}.      
    \end{aligned}
  \end{equation}
  %
  \fref{butter-example} shows the frequency response relative to the
  two extreme choices for $\ftaglio$.
\end{example}

\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{butterworth_example_1}
    &
    \unafigura[0.47\textwidth]{butterworth_example_zoom} \\
    (a) & (b)
  \end{tabular}
  \caption{Example of Butterworth filters \label{fig:butter-example}}
\end{figure}

\subsection{Poles of a Butterworth filter}

Butterworth filters provide a nice example of application of the
procedure described in Section~\ref{sec:abs2h}.  Let $\tfbutter(s)$
the transfer function associated with the frequency response
$\butter(f)$.  According to the procedure in Section~\ref{sec:abs2h},
%
\begin{equation}
  \overline\tfbutter(s)=
  \tfbutter(s)\tfbutter(-s) = \frac{1}{1+(-1)^{\order} \frac 1
    {(2\pi\ftaglio)^{2\order}} s^{2\order}}
\end{equation}
%
Therefore, the poles of $\overline\tfbutter(s)$ are the solutions of
equation
%
\begin{equation}
  1+(-1)^{\order} \frac {s^{2\order}}
    {(2\pi\ftaglio)^{2\order}} = 0
\end{equation}
%
equivalent to
%
\begin{equation}
  \label{eq.but.p}
  s^{2\order} = (-1)^{\order+1} (2\pi\ftaglio)^{2\order}
    = 
    \begin{cases}
      (2\pi\ftaglio)^{2\order} & \text{$\order$ odd} \\
      \exp(j\pi) (2\pi\ftaglio)^{2\order} & \text{$\order$ even} 
    \end{cases}
\end{equation}
%
The solutions for \er{eq.but.p} are
%
\begin{equation}
  \exp\left(j 2\pi \frac{k}{2\order}\right) 2\pi\ftaglio,
  \qquad k=0, \ldots, 2\order-1
\end{equation}
%
if $\order$ is odd and
%
\begin{equation}
  \exp\left(j 2\pi \frac{k+1/2}{2\order}\right) 2\pi\ftaglio,
  \qquad k=0, \ldots, 2\order-1  
\end{equation}
%
if $\order$ is even.  Therefore, $\overline\tfbutter$ has $2\order$
poles, equispaced on the circumference of radius $2\pi \ftaglio$,
shifted in phase by $\pi/2\order$ if $\order$ is even.  It is easy to
check that if $\order$ is odd two poles are real, if $\order$ is even
no poles are real; moreover no pole is on the imaginary axis,
both for $\order$ odd and even.  Clearly, the half of them with negative
real part are the poles of $\tfbutter(s)$.

\chapter{\cebi; filters}
\label{chap:cebi}

\begin{commento}
  About the way of transliterating the surname \cebi;, it is worth
  quoting the Wikipedia page

  \begin{quote}
    \em
The surname Chebyshev has been transliterated in several different
ways, like Tchebichef, Tchebychev, Tchebycheff, Tschebyschev,
Tschebyschef, Tschebyscheff, Čebyčev, Čebyšev, Chebysheff, Chebychov,
Chebyshov (according to native Russian speakers, this one provides the
closest pronunciation in English to the correct pronunciation in old
Russian), and Chebychev, a mixture between English and French
transliterations considered erroneous. It is one of the most well
known data-retrieval nightmares in mathematical literature. Currently,
the English transliteration Chebyshev has gained widespread
acceptance, except by the French, who prefer Tchebychev. The correct
transliteration according to ISO 9 is Čebyšëv. The American
Mathematical Society adopted the transcription Chebyshev in its
Mathematical Reviews. 
  \end{quote}
\end{commento}

\section{Motivation}

\section{Definition}

The frequency response of a \cebi;-I filter is
\begin{equation}
  \label{eq.c.f}
  \abs{\chebiI(f)}^2 = \frac{1}{1+\epsilon^2 \cebypoly^2(f/\ftaglio)}
\end{equation}
%
where $\order$ is the order of the filter, $\ftaglio$ the cut-off
frequency, $\epsilon$ a parameter related with $\rp$ and 
$\cebypoly$ is the \emph{\cebi; polynomial of order $\order$}
defined as
%
\begin{equation}
  \label{eq.c.def}
  \cebypoly(x) = \cos(\order \arccos(x))
\end{equation}
%
or via the recursive relation
%
\begin{subequations}
\label{eq:137;dispensa}
\begin{eqnarray}
\label{eq:137a;dispensa}
\cebypoly[0](x) &=& 1  \\
\label{eq:137b;dispensa}
\cebypoly[1](x) &=& x  \\
\cebypoly[N](x) &=& 2 x \cebypoly[N-1](x) - \cebypoly[N-2](x)
\qquad N \geq 2
\end{eqnarray}
\end{subequations}
%
\begin{commento}
  The right hand side of  \er{eq.c.def} does not look like a
  polynomial, but it is possible to prove that it is a polynomial by
  using the formulas of duplication of cosine.
\end{commento}

\subsection{Analysis of the frequency response}

In order to understand how the parameters $\order$, $\ftaglio$ and
$\epsilon$ influences the filter frequency response, it is worth first
to analyze the behavior of the \cebi; polynomial.

First observe that according to \er{eq.c.def},
%
\begin{equation}
  \cpoly(-x) = (-1)^{\order} \cpoly(x)
\end{equation}
%
that is, $\cpoly$ is even if $\order$ is even and odd otherwise.  This
means that $\cpoly^2$ is always even and this allows us to consider
only $x \geq 0$.  Moreover, it is easy to see that $\cpoly(1)=1$ while
%
\begin{equation}
  \cpoly^2(0)=
  \begin{cases}
    0 & \text{if $\order$ is odd} \\
    1 & \text{it $\order$ is even}
  \end{cases}
\end{equation}
%
If $\abs x \leq 1$, $\arccos x$ is real and this implies $\abs{\cpoly(x)}
\leq 1$ since $\cpoly(x)$ is the cosine of a real number.  That is,
for $\abs x\leq 1$, $\cpoly(x)$ oscillates between $-1$ and $1$ and,
therefore, $\cpoly^2(x)$ oscillates between $0$ and $1$.

If $\abs x > 1$, $\arccos x$ is an imaginary number  and its cosine
is the \emph{hyperbolic cosine} of $-j \arccos x$.  Since the
hyperbolic cosine is monotone increasing, it follows that $\cpoli(x)$
is monotone increasing and diverge to infinity for $x > 1$.

Summarizing, $\cpoli^2(x)$ oscillates between $0$ and $1$ when $\abs
x\leq 1$, it is always $\cpoli^2(\pm 1)=1$ and it diverges to $\infty$
(as $x^\order$) for $\abs x>1$. \fref{cpoli} shows few plots of
$\cpoli(x)$ and $\cpoli^2(x)$.

\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{polinomi_cheby}
    &
    \unafigura[0.47\textwidth]{polinomi_cheby_quadro} \\
    (a) & (b)\\
    \multicolumn{2}{c}{\unafigura[0.47\textwidth]{filtri_chebyshev}}
    \\
    \multicolumn{2}{c}{(c)} 
  \end{tabular}
  \caption{Plots of (a) \cebi; polynomials; (b) the squares of the
    polynomials in (a); (c) Frequency response of the corresponding
    filters (with $\epsilon=1$)  \label{fig:cpoli}}
\end{figure}


Using these results in \er{eq.c.f} we deduce that $\abs{\chebiI(f)}^2$
\begin{enumerate}
\item Oscillates between $1$ and $1/(1+\epsilon^2)$ when $f < \ftaglio$
\item It decreases monotonically to zero (as $f^{-2\order}$) when $f>\ftaglio$
\end{enumerate}
%
In other words, a \cebi;-I filter has an \emph{equiripple} behavior
(that is, it oscillates between $1$ and $\rp$) in pass-band and has a
monotonic behavior in stop-band.

\section{Design}

The design procedure is fairly easy.  Satisfy the specs in pass-band
by setting $\ftaglio=\fp$ and $1/(1+\epsilon^2) = \rp^2$, that is
%
\begin{equation}
  \label{eq.c.eps}
  \epsilon = \sqrt {1/\rp^2-1}
\end{equation}
%
Now we need to find $\order$ that satisfies the stop-band spec.  Since
the filter is monotone in stop-band, the specs are satisfied if and
only if they are satisfied on the band edge, that is, it must be,
remembering that $\ftaglio=\fp$,
%
\begin{equation}
  \frac{1}{1+\epsilon^2 \cebypoly^2(\fa/\fp)} \leq \ra^2
\end{equation}
%
which is equivalent to
%
\begin{equation}
  \cpoly^2(\fa/\fp) = \cosh(\order\arccosh(\fa/\fp)) \geq
  \frac{1/\ra^2-1}{\epsilon^2} =
    \frac{1/\ra^2-1}{1/\rp^2-1}  = \kbutter(\ra,\rp)
\end{equation}
%
which in turn gives, remembering \er{eq.c.eps}
%
\begin{equation}
  \cosh(\order\arccosh(\fa/\fp)) \geq
    \frac{1/\ra^2-1}{1/\rp^2-1}  = \kbutter(\ra,\rp)
\end{equation}
%
which, finally, is equivalent to
%
\begin{equation}
  \order \geq \frac{\arccosh(\kbutter(\ra,\rp))}{\arccosh(\fa/\fp)}
\end{equation}
%
Remembering that $\order$ must be integer
%
\begin{equation}
  \label{eq.c.order}
  \order = \ceil{\frac{\arccosh(\kbutter(\ra,\rp))}{\arccosh(\fa/\fp)}}
\end{equation}
%
\begin{commento}
  According to \er{eq.c.order}, $\order$ depends on $\fp$ and $\fa$
  only via their ratio, as expected.  Notice also that since for $x$
  large $\arccosh(x) \approx \ln(2x)$, the right hand side of
  \er{eq.c.order} can be interpreted as a value related with the slope
  in transition band.
\end{commento}

\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{butter_vs_cheby-order=4}
    &
    \unafigura[0.47\textwidth]{butter_vs_cheby_zoom_in_passband-order=4} \\
    (a) & (b)\\
    \unafigura[0.47\textwidth]{butter_vs_cheby-order=5}
    &
    \unafigura[0.47\textwidth]{butter_vs_cheby_zoom_in_passband-order=5} \\
    (c) & (d)\\
  \end{tabular}
  \caption{(a) Comparison of a Butterworth filter of order $\order=4$ with a
    \cebi; filter of the same order.  Both filters attenuate 3~dB at
    $\ftaglio=1$.  (b) Zoom in the passband of (a).
    (c) and (d) Like (a) and (b) but for $\order=5$
    \label{fig:butt-vs-cebi}}
\end{figure}

\begin{commento}[Butterworth and \cebi;]
  \fref{butt-vs-cebi} compares the frequency responses of a
  Butterworth filter and a \cebi;-I filter with the same order
  $\order$ and the same cut-off frequency $\ftaglio=1$; sub-figures (a)
  and (b) are for $\order=4$, while (c) and (d) are for $\order=5$;
  all the filters attenuate 3~dB at $\ftaglio$.

  Observe that the slopes of both types of filters gets parallel as
  the frequency increases, as expected since the asymptotic decay is
  the same; the advantage of \cebi; filters is in the ``attack'' at
  $\fp$ (see \fref{butt-vs-cebi}b and d): while the amplitude of the
  Butterworth filter decreases smoothly, the amplitude of the
  Chebyshev filter decreases sharply at $\fp$.
\end{commento}

\section{\cebi;-II filters}

\cebi;-I filters are equiripple in pass-band and monotone in
stop-band; we can get the dual behavior (monotone in pass-band and
equiripple in stop-band) with the \cebi;-II filters obtained by
``reversing'' the \cebi;-I ones.

The frequency response of a \cebi;-II filter with $\ftaglio=1$ is
%
\begin{equation}
  \label{eq.c2.def}
  \abs{\cebiII[\order,1,\epsilon](f)}^2
  = 1-\abs{\cebiI[\order,1,\epsilon](1/f)}^2 =
  \frac{\epsilon^2 \cpoli^2(1/f)}{1+\epsilon^2 \cpoli^2(1/f)}
\end{equation}
%
\begin{commento}
  In \er{eq.c2.def} the substitution of $f$ with $1/f$ ``reverses''
  the frequency axis, mapping $f=0$ to $\infty$ and vice-versa.  This
  reversal of the frequencies transforms the low-pass filter into a
  high-pass; to get a a low pass again we flip also the amplitude axis
  around $1/2$ with the map $A \mapsto 1-A$.  
\end{commento}
%
By writing $\cpoli^2(x) = \sum_{k=0}^{2\order} c_k x^k$ we can rewrite
\er{eq.c2.def} as
%
\begin{equation}
  \begin{aligned}
    \abs{\cebiII[\order,1,\epsilon](f)}^2
    &=
    \frac
        {\epsilon^2 \sum_{k=0}^{2\order} c_k f^{-k}}
        {1+\epsilon^2 \sum_{k=0}^{2\order} c_k f^{-k}} \\
        &= \frac{\epsilon^2 \sum_{k=0}^{2\order} c_k f^{2\order-k}}{1+\epsilon^2
    \sum_{k=0}^{2\order} c_k f^{2\order-k}}
  &&\text{Multiply by $f^{2\order}$ }
  \\
  &= \frac{\epsilon^2 \sum_{m=0}^{2\order} c_{2\order-m} f^{m}}{1+\epsilon^2
    \sum_{m=0}^{2\order} c_{2\order-m} f^{m}}
  &&\text{Set $m=2\order-k$}
  \end{aligned}
\end{equation}
%
which shows that $\abs{\cebiII[\order,1,\epsilon](f)}^2$ is a rational
function with both poles and zeros and that the zeros of
$\abs{\cebiII[\order,1,\epsilon](f)}^2$ are the reciprocal of the
zeros of $\cpoli(f)$; that is, if $\cpoli(f_0)=0$, then
$\abs{\cebiII[\order,1,\epsilon](1/f_0)}^2=0$; this can also be seen
directly from \er{eq.c2.def}.  This implies that the transfer function
of a \chebi;-II filter has zeros on the imaginary axis.

\begin{figure}
  \centering
    \unafigura{esempi-chebi2-linear}
  \caption{Examples of frequency response of few \cebi;-II filters;
    the vertical axis is in linear scale rather than dB in order to
    show more clearly the equiripple behavior in stop-band.
    \label{fig:esempi-cebi2}}
\end{figure}

\begin{example}
\fref{esempi-cebi2} shows the frequency response of some \cebi;-II filters;
    the vertical axis is in linear scale rather than dB in order to
    show more clearly the equiripple behavior in the stop-band.
    Observe where the frequency response touches the horizontal axis:
    those are the predicted zeros on the imaginary axis.
\end{example}


\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{chebi2_discrete-order=6}
    &
    \unafigura[0.47\textwidth]{chebi2_discrete_zeri_e_poli-order=6}\\
    (a) & (b)\\
    \unafigura[0.47\textwidth]{chebi2_discrete-order=7}
    &
    \unafigura[0.47\textwidth]{chebi2_discrete_zeri_e_poli-order=7}\\
    (c) & (d)\\
  \end{tabular}
  \caption{(a) Frequency response of a digital filter obtained by
    discretization via bilinear transform of a \cebi;-II filter of
    order $\order=6$ (b) Zeros and poles of the filter in (a).
    (c) and (d) like (a) and (b) but for a filter
    of order $\order=7$.  
    \label{fig:cebi2-discrete}}
\end{figure}

\begin{example}
  \fref{cebi2-discrete}a shows the frequency response of a digital
  filter obtained by discretization via bilinear transform of a
  \cebi;-II filter of order $\order=6$; the zero-pole diagram is shown
  in \fref{cebi2-discrete}b.  Sub-figures (c) and (d) show the same
  information, but for $\order=7$.  Observe how the zeros in frequency
  of the analog prototype (see \fref{esempi-cebi2}) are mapped to
  zeros on the unit circle by the bilinear transform.  Observe also
  that the case $\order=7$ has a real zero in $z=-1$ that corresponds
  to the zero for $f \to \infty$ of the analog counterpart.
\end{example}

\chapter{Elliptic filters}
\label{chap:elliptic}

The idea for \cebi; filters was that if we ``spread'' the error in the
pass-band/stop-band, we make a ``better use'' of the specs and we are
able to satisfy them with a smaller order.  Here we take this idea one
step further, searching for filters that are equiripple both in the
pass-band and the stop-band.  The resulting filter class is the
\emph{elliptic filter class}.

\section{Definition}

The frequency response of an elliptic filter is
%
\begin{equation}
  \label{eq.ell.def}
  \abs{\elliptic(f)}^2 = \frac{1}{1+\epsilon^2 \ellrat^2(\xi,f/\ftaglio)}
\end{equation}
%
where $\xi$ is an additional parameter (beside $\order$, $\ftaglio$
and $\epsilon$) that controls the frequency response and $\ellrat =
Q_\order(\xi,x)$ with $Q_\order$ the \emph{elliptic rational
function of order $\order$}.  Note that in notation $\elliptic$ we
omitted parameters $\order$ and $\ftaglio$ in order to make the
notation lighter.

The definition of $\ellrat$ is definitively too complex, it requires
the knowledge of elliptic function theory and its detailed study it
would take us too afar.  We will analyze the frequency response
\er{eq.ell.def} by exploiting the following properties of $\ellrat$

\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{ellip_function}
    &
    \unafigura[0.47\textwidth]{ellip_function_squared} \\
    (a) & (b)\\
    \multicolumn{2}{c}{\unafigura[0.47\textwidth]{ellip_zeros_and_poles}}
    \\
    \multicolumn{2}{c}{(c)} 
  \end{tabular}
  \caption{(a) Plots of some elliptic rational functions. (b) Square
    of the plots in (a).  (c) Zeros and poles of the rational elliptic
    function of order $\order=4$ with $\xi=1.4$.  Note the symmetry
    around the red dash-and-dot line which corresponds to $x=\sqrt\xi$
    induced by the map $x \mapsto \xi/x$ (and the fact that the
    horizontal axis is on a logarithmic scale).
    \label{fig:ellip-fun}}
\end{figure}

\begin{enumerate}
\item Function $\ellrat(x)$ is even if $\order$ is even, odd if
  $\order$ is odd.  It follows that $\ellrat^2(x)$ is always even.
\item $\ellrat^2(\pm 1)=1$ for every $\order$ and $\xi$
\item For every $\xi$, function $\ellrat(x)$ oscillates
  between $-1$ and $1$ when $\abs x <1$; therefore, $0\leq
  \ellrat^2(x) \leq 1$ for every $\abs x \leq 1$.
\item The following ``inversion rule'' holds
  \begin{equation}
    \ellrat\left(\frac \xi x\right)
    = \frac{\ellrat(\xi)}{\ellrat(x)}
  \end{equation}
\end{enumerate}
%
Observe that the first three properties resemble the behavior of
\cebi; polynomials in $[-1,1]$; indeed, \cebi; polynomials can be
obtained as a special case of elliptic rational functions with
$\xi=\infty$. Because of said properties, we expect an equiripple
behavior in pass-band like with \cebi;-I filters.  See also
\fref{ellip-fun} for some example of elliptic rational functions in
$[-1,1]$ (\fref{ellip-fun}a) and their squares (\fref{ellip-fun}b).

The inversion rule implies
%
\begin{equation}
  \label{eq.ell.osc}
  x > \xi \implica \ellrat^2(x)
  = \frac{\ellrat^2(\xi)}{\ellrat^2(\xi/x)}
  \geq \ellrat^2(\xi)
\end{equation}
%
Equation \er{eq.ell.osc} shows that the inversion rule ``transfers'' the
oscillator behavior from the interval $[-1,1]$ to the interval
$[\xi,+\infty]$.  Moreover, \er{eq.ell.osc} with \er{eq.ell.def}
implies that
\begin{equation}
  \begin{aligned}
  f < \ftaglio & \implica
  \abs{\elliptic(f)}^2 \geq
  \frac{1}{1+\epsilon^2}
  \\
  f> \xi \ftaglio &\implica
  \abs{\elliptic(f)}^2 \leq
  \frac{1}{1+\epsilon^2 \ellrat^2(\xi)}
  \end{aligned}
\end{equation}
%
This suggests that the elliptic filter will have an equiripple
behavior in pass-band with $\rp=1/(1+\epsilon^2)$ and an equiripple
behavior in stop-band with $\ra=1/(1+\epsilon^2\ellrat^2(\xi))$.

\begin{figure}
  \centering
  \begin{tabular}{cc}
    \unafigura[0.47\textwidth]{ellip_R_and_filter}
    &
    \unafigura[0.47\textwidth]{ellip_R_and_filter_zoom} \\
    (a) & (b)
  \end{tabular}
  \caption{(a) An elliptic rational function (red, dashed line) and the
    frequency response of the corresponding filter (blue, solid
    line).  Vertical dashed lines mark the edges of the bands. (b)
    Zoom of the frequency response in (a) to emphasize the equiripple
    behavior in stop-band. 
    \label{fig:ellip-filter}}
\end{figure}


%\chapter{Implementation}
\label{chap:implementation}

\appendix

\chapter{Basics of time-frequency analysis}
\label{app:tf}

\section{Introduction}
\subsection{Motivation: from \ttt WAV! to score}

Suppose you have a recording of some music and you want to convert
that recording in a score.  This requires to find out which notes are
played, when they are played and how long they last.  A possible
solution to this problem could be to use a bank of pass-band filters,
where each filter is tuned around a specific note and we detect the
energy of the output of each filter.

How do we design each filter?  We need filters sufficiently selective
so they do not ``sense'' the adjacent notes; for example, the filter
for \ttt D! should respond in a negligible way to the adjacent \ttt
C\#! and \ttt D\#!. We can get the \ttt D! filter as selective as we
want, but this would require longer filters that ``blur'' the temporal
duration of the note.  This can be a problem especially with very
short notes such as in trills where the note could be ``mashed up'' in
a single event, if the time duration of the impulse response is much
longer than the duration of the note.

Therefore, we want a filter that is concentrated in frequency (to
separate notes with small frequency differences) and in time (to
separate very short notes).  In order to give a precise meaning to the
expression ``concentrated in time/frequency,'' we need to define a
conventional time/frequency support for a signal.  The definition
needs to be necessarily conventional since, as it is well known, there
are no signal that are compactly supported both in time and frequency.

\subsection{Notation}

In this chapter we will use the following definition \er{eq.for} of
the Fourier transform that we will denote with $\fourier:\Elldue\reali
\to \Elldue\reali$
%
\begin{subequations}
  \label{eq.for}
  \begin{align}
    [\fourier g](f) & = \int_\reali g(t) \exp(-j2\pi f t)= \h[G](f)
    \;dt \\
         [\inv\fourier \h[G]](t) &= \int_\reali \h[G](f) \exp(j2\pi f t)\; df
  \end{align}
\end{subequations}
%
With this definition the Fourier transform is unitary, that is,
$\norma{\fourier g}=\norma{g}$.


\section{Conventional time/frequency support}

\subsection{A special case: support of a probability density function}

Let $g : \reali \to \reali$ be a signal in $\Elldue\reali$.  A
convenient way to define the conventional support of $g$ stems from
the following observation: suppose, for a moment, that $g$ is actually
the probability density function (pdf) of some random variable $X$; we know that
the values assumed by $X$ are concentrated around its mean
%
\begin{equation}
  m_X = \mean X = \int_\reali x \;g(x) dx
\end{equation}
%
and that a measure of the ``dispersion'' of $X$ around $m_X$ is given
by its standard deviation $\sigma_X$
%
\begin{equation}
  \sigma_X = \sqrt{\mean {(X-m_X)^2}} =
  \sqrt{\int_\reali (x-m_X)^2 g(x) dx}
\end{equation}
%
This suggests that \textbf{if $g$ is a probability density function},
then we can take as its conventional support an interval with length
$\sigma_X$ and centered around $m_X$.

\paragraph{The general case}
What if $g$ is \textbf{not} a probability density function?  Easy, we
force it to be.  Remember that the two properties that characterize a
pdf are that the pdf is never negative and its integral over $\reali$
is equal to $1$.  This suggests to associate to $g$ the pdf
%
\begin{equation}
  p_g(t) \perdef \frac{\abs{g(t)}^2}{\norma g^2} 
\end{equation}
%
where
%
\begin{equation}
  \norma g^2 = \int_\reali \abs{g(t)}^2 dt
\end{equation}
%
is granted to exists since $g\in\Elldue \reali$.  Note that $p_g$ is a
pdf since it satisfies the two properties of a pdf.

Intuitively, taking the square and dividing by a constant it does not
change how the signal energy is distributed in time and this suggests
that it is reasonable to take the conventional support of the
associated pdf $p_g$ as conventional support of $g$.  Notationally, we
will denote with $m_t$ the center of the support in time and with $\sigma_t$ its size, that is,
%
\begin{subequations}
  \begin{align}
 m_t &= \int_\reali x \;  \frac{\abs{g(x)}^2}{\norma g^2} dx  \\
  \sigma_t &= 
  \sqrt{\int_\reali (x-m_t)^2 \frac{\abs{g(x)}^2}{\norma g^2} dx}
  \end{align}
\end{subequations}
%
Since $g \in\Elldue\reali$, by Parseval, even its Fourier transform
$\h[G](f)$ belongs to $\Elldue\reali$; therefore, we can repeat the
same construction with $\h[G]$ to obtain 
%
\begin{subequations}
  \begin{align}
 m_f &= \int_\reali f \;  \frac{\abs{\h[G](f)}^2}{\norma {\h[G]}^2} df  \\
  \sigma_f &= 
  \sqrt{\int_\reali (f-m_f)^2 \frac{\abs{\h[G](f)}^2}{\norma {\h[G]}^2} df}
  \end{align}
\end{subequations}
%
that represent the frequency support of $g$.  The Cartesian product of
the time and frequency supports is called the \emph{tile in the
time-frequency plane} associated with $g$.


\begin{commento}
\label{rem.cons}
Observe that the supports in time/frequency enjoy the following
properties,

\begin{enumerate}
\item If $g$ is multiplied by a constant, neither the time support nor
  the frequency support change
\item If $g$ is translated by $\tau$, the time support is translated
  by $\tau$ and the frequency support does not change
\item If $g$ is multiplied by $\exp(j 2\pi f_0 t)$, the frequency
  support is translated by $f_0$ and the time support does not
  change
\item If $h(t)=g(\alpha t)$ (that is, $h$ is a time-stretched version
  of $g$), then $\sigma_t$ is multiplied by $1/\alpha$ and $\sigma_f$
  is multiplied by $\alpha$.
\end{enumerate}
%
  Note that none of the above operation changes the area of the
  time-frequency tile and that the only one that changes the shape is
  the stretching that allows to change the ratio between the time
  support and the frequency support, moving from  a signal with a
  small support in time and large in frequency to a signal with a
  large support in time and small in frequency.
\end{commento}
%
Remember that our objective is to find a signal $g$ ``well
concentrated'' both in time and frequency, that is with both
$\sigma_t$ and $\sigma_f$ small. Therefore, it is of interest to see how
small we can make the product $\sigma_t \sigma_f$; if we can make it
arbitrarily small, then we can make $g$ as selective in frequency and
as short in time as we want; if instead $\sigma_t \sigma_f$ has a
lower bound, then we need to compromise: if we want selectivity we
cannot have short filters and vice-versa.
%

\begin{theorem}
  For every signal $g \in \Elldue\reali$ such that
  $t\,g(t)\in\Elldue\reali$ the following inequality holds
  \begin{equation}
    \label{eq.bound}
    \sigma_t \sigma_f \geq \frac{1}{4\pi}
  \end{equation}
  %
  Bound \er{eq.bound} is satisfied with the equality sign if $g(t)=c
  \exp(-k t^2)$ for some real constants $k$ and $c$.
\end{theorem}
%
\begin{commento}
  The bound $1/4\pi$ in \er{eq.bound} depends on the specific
  definition of the Fourier transform, other definitions (e.g., using
  radians/s rather than Hz as unit of frequency) can give rise to
  different (but equivalent) bounds.
\end{commento}
%
\begin{proof}
  We will assume, without loss of generality, that
  %
  \begin{subequations}
    \label{eq.ip}
    \begin{align}
      m_t&=0 \\
      m_f&=0 \\
      \norma g&=1
    \end{align}
  \end{subequations}
   since by using the operations listed in Remark~\ref{rem.cons}, we
   can force $g$ to satisfy \er{eq.ip} without changing $\sigma_t$ and
   $\sigma_f$.

   It will prove convenient to define some notation.  With $\X$ we
   will denote the operator that multiplies its argument (a signal) by
   the identity function, that is,
   %
   \begin{equation}
     [\X g](t) = [\id \cdot g](t) = t \cdot g(t)
   \end{equation}
   %
   In other words, $\X$ multiply its argument by the independent
   variable. With $\partial$ we will denote the derivative operator,
   that is, 
   %
   \begin{equation}
     [\partial g](t) = g'(t)
   \end{equation}
   %
   Finally, observe that
   %
   \begin{subequations}
     \begin{align}
       \norma{g} &= \norma{\fourier g} && \text{$\fourier$ is unitary}
       \\
       \label{eq.zb}
       \fourier \partial &= j2\pi \X \fourier
       &&\text{$\partial$ and $\X$ are dual}
     \end{align}
   \end{subequations}
   %
   Now observe that if $g$ satisfies \er{eq.ip}, then we can write
   $\sigma_t$ as
   \begin{equation}
     \sigma_t = \sqrt{\int_\reali t^2 \abs{g(t)}^2\;dt} = \norma{\X g}
   \end{equation}
   %
   Moreover,
   %
   \begin{equation}
     \begin{aligned}
       \sigma_f
       &= \norma{\X \fourier g}\\
       &= \norma{(1/j2\pi) \fourier \partial g}
       &&\text{See \er{eq.zb}} \\
       &= \frac{1}{2\pi} \norma{\fourier \partial g} \\
       &= \frac{1}{2\pi} \norma{\partial g}
       &&\text{$\fourier$ is unitary}
     \end{aligned}
   \end{equation}
   %
   Therefore,
   %
   \begin{equation}
     \label{eq.aq0}
     \sigma_t\sigma_f = \frac{1}{2\pi} \norma{\partial g}\norma{\X g}
   \end{equation}
   %
   We can lower bound the product $\norma{\partial g}\norma{\X g}$ by
   using the Cauchy–Schwartz inequality
   %
   \begin{equation}
     \label{eq.aq1}
     \norma{\partial g}\norma{\X g} \geq
     \abs{\scalprod{\partial g}{\X g}}
   \end{equation}
   %
   In order to find a bound to the scalar product, write it
   explicitly
   \begin{equation}
     \label{eq.aq2}
     \begin{aligned}
       \scalprod{\partial g}{\X g}
       &= \int_\reali [\partial g](t) [\X g](t)\; dt\\
       &= \int_\reali t g'(t) g(t) \; dt\\
       &= \int_\reali t \commenta{\left(\frac 12 \frac {d\,
           g^2}{dt}(t)\right)}{g'(t)g(t)}  \;dt \\
       &= \commenta{\left.\frac 12 t
         g^2(t)\right|_{-\infty}^{+\infty}}{=0}
       -\frac 12 \commenta{\int_\reali g^2(t) \; dt}{=1}
       &&\text{Integration by parts}
     \end{aligned}
   \end{equation}
   %
   where we used the hypothesis that $\lim_{t\to \pm\infty} t
   g^2(t)=0$.  By using \er{eq.aq1} and \er{eq.aq2} in \er{eq.aq0}  we
   obtain
   \begin{equation}
     \sigma_t\sigma_f = \frac{1}{2\pi} \norma{\partial g}\norma{\X g}
     \geq \frac{1}{2\pi}\abs{\scalprod{\partial g}{\X g}} =
     \frac{1}{4\pi} 
   \end{equation}
   %
   In order to prove that the bound \er{eq.bound} is achieved when $g$
   is a Gaussian, remember that the Cauchy–Schwartz inequality is
   satisfied with equality if the two vectors ($\partial g$ and $\X g$
   in this case) are ``parallel,'' that is they differ by the product
   of a constant that we will call $k$.  Therefore, the following
   differential equation is a sufficient
   condition for equality in \er{eq.bound} 
   %
   \begin{equation}
     \label{eq.diff}
     g'(t) = k \,t\, g(t)
   \end{equation}
   %
   It is easy to verify that a solution to \er{eq.diff} is
   %
   \begin{equation}
     g(t) = (c/2) \exp(k\, t^2)
   \end{equation}
   %
   for any constant $c$.  Clearly, since we require $g \in
   \Elldue\reali$ it must be $k <0$.
\end{proof}

\end{document}

% LocalWords:  eq Butterworth lcp Equiripple eqz eqa eqs sl fc bessel
% LocalWords:  filtri rescaled DSP bilinear monotonicity butterworth
% LocalWords:  equispaced Chebyshev Tchebichef Tchebychev Tchebycheff
% LocalWords:  Tschebyschev Tschebyschef Tschebyscheff Čebyčev cpoli
% LocalWords:  Čebyšev Chebysheff Chebychov Chebyshov Chebychev cheby
% LocalWords:  Čebyšëv polinomi quadro chebyshev equiripple passband
% LocalWords:  cebi esempi chebi zeri poli discretization ellip WAV
% LocalWords:  dt df pdf dx Parseval ip zb aq
